
Ruby - Bug #16239

Crash when accessing postgresql-12

10/04/2019 05:59 PM - marksiemers (Mark Siemers)

Status: Third Party's Issue   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.6.4p104 (2019-08-28 revision

67798) [x86_64-darwin18]

Backport: 2.5: UNKNOWN, 2.6: UNKNOWN

Description

This may have been caused by a recent upgrade to postgresql 12 on my local machine (running OS X Mojave). pgAdmin 4 is also

giving me an error.

I am running a rails console, and as soon as I try to do anything with ActiveRecord that accesses the database, I get an error and a

crash report,

Related issues:

Related to Ruby - Bug #16385: Segmentation fault when running a rails app wit... Third Party's Issue

Related to Ruby - Bug #16390: Crash report for ruby2.6.4p104 Third Party's Issue

History

#1 - 10/04/2019 05:59 PM - marksiemers (Mark Siemers)

- Subject changed from Crash when access postgresql-12 to Crash when accessing postgresql-12

#2 - 10/04/2019 06:04 PM - marksiemers (Mark Siemers)

- ruby -v set to ruby 2.6.4p104 (2019-08-28 revision 67798) [x86_64-darwin18]

#3 - 10/04/2019 06:11 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Open to Third Party's Issue

This crash happens inside the pg gem. It's either caused by the pg gem, libpq (PostgreSQL), or one of the internal Mac OS libraries listed.

7   ???                            0x0000000200000000 0 + 8589934592

8   com.apple.security             0x00007fff3f57c059 invocation function for block in Security::KeychainCore:

:StorageManager::tickleKeychain(Security::KeychainCore::KeychainImpl*) + 287

9   libdispatch.dylib              0x00007fff5fd6d63d _dispatch_client_callout + 8

10  libdispatch.dylib              0x00007fff5fd79129 _dispatch_lane_barrier_sync_invoke_and_complete + 60

11  com.apple.security             0x00007fff3f57be47 Security::KeychainCore::StorageManager::tickleKeychain(S

ecurity::KeychainCore::KeychainImpl*) + 441

12  com.apple.security             0x00007fff3f37cae2 Security::KeychainCore::KCCursorImpl::next(Security::Key

chainCore::Item&) + 230

13  com.apple.security             0x00007fff3f523c98 Security::KeychainCore::IdentityCursor::next(Security::S

ecPointer<Security::KeychainCore::Identity>&) + 192

14  com.apple.security             0x00007fff3f545f2f SecIdentitySearchCopyNext + 145

15  com.apple.security             0x00007fff3f550956 SecItemCopyMatching_osx(__CFDictionary const*, void cons

t**) + 238

16  com.apple.security             0x00007fff3f553fc5 SecItemCopyMatching + 316

17  com.apple.Heimdal              0x00007fff4feae830 0x7fff4fe5c000 + 337968

18  com.apple.Heimdal              0x00007fff4fead35e hx509_certs_find + 67

19  com.apple.Heimdal              0x00007fff4fe88a6c _krb5_pk_find_cert + 246

20  com.apple.GSS                  0x00007fff364dbd8e _gsspku2u_acquire_cred + 386

21  com.apple.GSS                  0x00007fff364cb0d8 gss_acquire_cred + 523

22  libpq.5.dylib                  0x0000000112b4b77d pg_GSS_have_cred_cache + 54

23  libpq.5.dylib                  0x0000000112b39edf PQconnectPoll + 6377

24  libpq.5.dylib                  0x0000000112b36f8b connectDBComplete + 232

25  libpq.5.dylib                  0x0000000112b37112 PQconnectdb + 36

26  pg_ext.bundle                  0x000000011157ab01 gvl_PQconnectdb_skeleton + 17

27  ruby                           0x000000010f1dfff9 call_without_gvl + 185

28  pg_ext.bundle                  0x000000011157aadd gvl_PQconnectdb + 45

29  pg_ext.bundle                  0x000000011157fcb9 pgconn_init + 121

30  ruby                           0x000000010f221b1c vm_call0_body + 604
 If I had to guess, this is a PostgreSQL issue with GSS authentication on Mac OS.  Since PostgreSQL 12 was just released, it may be a regression. 

Please try contacting the PostgreSQL developers.

#4 - 12/02/2019 03:43 PM - jeremyevans0 (Jeremy Evans)

- Related to Bug #16385: Segmentation fault when running a rails app with puma added

#5 - 12/02/2019 04:36 PM - jeremyevans0 (Jeremy Evans)

- Related to Bug #16390: Crash report for ruby2.6.4p104 added

#6 - 12/04/2019 09:10 PM - cbandy (Chris Bandy)

@jeremyevans0 (Jeremy Evans) is correct. This is a fatal interaction between the PostgreSQL 12 client libraries and the GSS implementation

provided by macOS. This is being tracked in the pg gem at https://github.com/ged/ruby-pg/issues/311.

An immediate workaround is to include gssencmode: "disable" or gssencmode=disable in your connection configuration.
